<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
    py:extends="'master.kid'">
<head>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
<title>Welcome to TurboGears</title>
</head>
<body>

  <h1>Advanced Identity Examples</h1>

  <p>This small TurboGears example project demonstrates how to use several
  advanced features of the <a href="http://docs.turbogears.org/1.0/Identity"
  >identity framework</a>:</p>
  <ul>
    <li>How to use a callable for <code>identity.failure_url</code></li>
    <li>How to build and use a custom identity predicate</li>
    <li>How to handle identity error messages</li>
  </ul>

  <p>If you click on one of the "Restricted area" links below, you will be
  redirected to a login form as normal, when you are not logged in. But when
  you are already logged in and try to access a page that requires special
  access privileges (like in the case of the "Restricted area 2" link), you
  will be redirected to a page that shows an "Access denied" message.</p>

  <p>Start with creating a test user by clicking on the "Create test
  user" link below. Then try out the links before and after logging in.
  Finally, look at the source code in the <code>controllers.py</code> file
  to see how it is done.</p>

  <p><a href="${tg.url('/create_user')}">Create a test user</a>.</p>
  <p><a href="${tg.url('/toggle_admin')}">Toggle admin state</a>.</p>
  <p py:if="tg.identity.anonymous">
    <a href="${tg.url(tg.identity.login_url)}">Login</a>
  </p>
  <p><a href="${tg.url('/restricted1')}">Restricted area 1
      (no anonymous users)</a>.</p>
  <p><a href="${tg.url('/restricted2')}">Restricted area 2
      (admins only)</a>.</p>
</body>
</html>
